import os
import sys
import shutil
import re
import json
import ConfigParser

re_class = r'[a-zA-Z]+[0-9a-zA-Z_]*(\.[a-zA-Z]+[0-9a-zA-Z_]*)*\.[a-zA-Z]+[0-9a-zA-Z_]*(\$[a-zA-Z]+[0-9a-zA-Z_]*)*'
re_package = r'[a-zA-Z]+[0-9a-zA-Z_]*(\.[a-zA-Z]+[0-9a-zA-Z_]*)*'


def cpy_file(src, dst):
    if not os.path.exists(src):
        print("[-] src not exist!")
        return
    if not os.path.exists(dst):
        os.mkdir(dst)
    for root, dirs, files in os.walk(src, True):
        for f in files:
            shutil.copy(os.path.join(root, f), dst)


def cpy_path(src, dst):
    if not os.path.exists(src):
        print("[-] src not exist: " + src)
        sys.exit()
    names = os.listdir(src)
    if not os.path.exists(dst):
        os.mkdir(dst)
    for name in names:
        src_name = os.path.join(src, name)
        dst_name = os.path.join(dst, name)
        try:
            if os.path.isdir(src_name):
                cpy_path(src_name, dst_name)
            else:
                if (not os.path.exists(dst_name)
                        or ((os.path.exists(dst_name))
                            and (os.path.getsize(dst_name) != os.path.getsize(src_name)))):
                    # print dst_name
                    shutil.copy2(src_name, dst)
        except:
            break


def patch_line_in_file(path, old, new, is_regular=False):
    rf = open(path, 'r')
    data = ''
    for line in rf:
        if is_regular:
            # here old is patten
            p = re.compile(old)
            if p.search(line):
                print("[*] patching file line: " + old + " ....")
                line = p.sub(new, line)
        else:
            if old in line:
                print("[*] patching file line: " + old + " ....")
                line = line.replace(old, new)
        data += line
    rf.close()
    wf = open(path, 'w')
    wf.write(data)
    wf.close()


def patch_file(path, old, new, is_regular=False):
    rf = open(path, 'r')
    data = ''
    for line in rf:
        data += line
    if is_regular:
        # compile dot all
        p = re.compile(old, re.DOTALL)
        if p.search(data):
            # print p.search(data).group()
            print("[*] patching file: " + old + " ....")
            data = p.sub(new, data)
    else:
        if old in data:
            print("[*] patching file: " + old + " ....")
            data = data.replace(old, new)
    rf.close()
    wf = open(path, 'w')
    wf.write(data)
    wf.close()


def str2unicode(str):
    ret = ''
    for v in str:
        if u'\u4e00' <= v <= u'\u9fff':
            ret = ret + hex(ord(v)).replace('0x', '\\u')
        else:
            ret = ret + v
    return ret


def int2hex(value):
    return hex(value)


kilobytes = 1024
megabytes = kilobytes * 1024
default_chunk_size = int(1 * megabytes)


def split(from_file, to_dir, chunk_size=default_chunk_size):
    part_num = 0
    input_file = open(from_file, 'rb')
    while True:
        chunk = input_file.read(chunk_size)
        if not chunk:
            break
        part_num += 1
        filename = os.path.join(to_dir, (input_file.name.split(os.sep)[-1] + '.split%d' % (part_num - 1)))
        file_obj = open(filename, 'wb')
        file_obj.write(chunk)
        file_obj.close()
    return part_num


if __name__ == '__main__':
    # conf = ConfigParser.ConfigParser()
    # conf.read('../inject.ini')
    #
    # str = conf.get('DEFAULT', 'charge_points')
    # print str
    #
    # json_arr = json.loads(str)
    #
    # print json_arr
    #
    # for json in json_arr:
    #     print str2unicode(json['title'])
    #     print int2hex(json['price'])
    #
    # count = 0
    # count += 1
    # print count

    print str(split('level0', '.'))
    print str(split('level2', '.'))
    print str(split('level1', '.'))
    print str(split('sharedassets0.assets', '.'))
    print str(split('sharedassets1.assets', '.'))
    print str(split('sharedassets2.assets', '.'))


    # a = r'(<string name="app_name">.+</string>)'
    # p = re.compile(a)
    # s = 'dd    <string name="app_name">xiaoqs</string>     d'
    # if p.search(s):
    #     print p.sub(' <string name="app_name">aaaaa</>', s)
